#include "Action.h"
#include <nlp_config.h>
#include <nlp_macros.h>


String_dq_t		Command::dq_Commands;
bool_dq_t		Command::dq_IsTyping;
bool_dq_t		Command::dq_NeedsObject;
bool_dq_t		Command::dq_NeedsParam;
int 			Command::i_Count;


//													
void Command::Load (void)
{
	String sCommands = (config)"action_list";

	String_dq_t dqCommands;
	sCommands.Split (dqCommands, '|');

	ITERATE (String_dq_t, dqCommands, ite)
	{
		String_dq_t dqValues;
		(*ite).Split (dqValues, ':');

		dq_Commands.push_back (dqValues [0]);
		dq_IsTyping.push_back (dqValues [0].Has ("type"));
		dq_NeedsParam.push_back ("p" == dqValues [2]);
		dq_NeedsObject.push_back ("o" == dqValues [3]);
	}

	i_Count = dq_Commands.size ();
}


//													
void Command::Clear (void)
{
	dq_Commands.clear ();
	dq_IsTyping.clear ();
	dq_NeedsObject.clear ();
	dq_NeedsParam.clear ();
}


//													
RLAction::RLAction (void)
{
	i_SelectedObjectWordLocation = -1;
	i_SelectedCommandWordLocation = -1;
	i_SelectedParameterWordLocation = -1;

	i_SelectedObjectIndex = -1;
	p_SelectedObject = NULL;
	i_SelectedCommandIndex = -1;
}


//													
bool RLAction::operator== (const RLAction& _rOther)
{
	if (i_SelectedObjectIndex != _rOther.i_SelectedObjectIndex)
		return false;
	if (i_SelectedCommandIndex != _rOther.i_SelectedCommandIndex)
		return false;
	if (i_SelectedObjectWordLocation != _rOther.i_SelectedObjectWordLocation)
		return false;
	if (i_SelectedCommandWordLocation != _rOther.i_SelectedCommandWordLocation)
		return false;
	if (i_SelectedParameterWordLocation != _rOther.i_SelectedParameterWordLocation)
		return false;

	return true;
}


//													
std::ostream& operator<< (std::ostream& _rStream, const RLAction& _rAction)
{
	_rStream << "wc:" << (int)_rAction.i_SelectedCommandWordLocation
			 << "  wu:" << (int)_rAction.i_SelectedObjectWordLocation
			 << "  wp:" << (int)_rAction.i_SelectedParameterWordLocation
			 << "  c:" << (int)_rAction.i_SelectedCommandIndex
			 << "  u:" << (int)_rAction.i_SelectedObjectIndex;
	return _rStream;
}





