#ifndef __LEARNER_ANNOTATION__
#define __LEARNER_ANNOTATION__

#include <map>
#include <nlp_string.h>
using namespace std;


#define ANNOTATION_UNKNOWN	'u'
#define ANNOTATION_PARTIAL	'p'
#define ANNOTATION_FULL		'f'
#define ANNOTATION_DELETED	'd'


class Annotation;
class AnnotatedSentence;
class AnnotatedAction;
typedef map <String, Annotation*>		IdToAnnotation_hmp_t;
typedef deque <AnnotatedSentence*>		AnnotatedSentence_dq_t;
typedef deque <AnnotatedAction*>		AnnotatedAction_dq_t;



// ------------------------------------------------------
class AnnotatedAction
{
	public:
		String	s_Command;
		int		i_CommandWord;
		int		i_ObjectWord;
		int		i_Parameter;
		String	s_ObjectName;
		String	s_ObjectType;
		String	s_TemporallyUniqueObjectId;
		bool	b_Optional;

		AnnotatedAction (void);
};



// ------------------------------------------------------
class AnnotatedSentence
{
	public:
		String					s_Text;
		AnnotatedAction_dq_t	dq_Action;

		~AnnotatedSentence (void);
};



// ------------------------------------------------------
class Annotation
{
	private:
		static IdToAnnotation_hmp_t		hmp_IdToAnnotation;

		static bool LoadAnnotation (char _cType);

	public:
		String					s_ID;
		AnnotatedSentence_dq_t	dq_Sentence;
		char					c_Type;

		Annotation (String& _rID, char _cType);
		~Annotation (void);

		static Annotation* Find (String& _rID);
		static bool Load (void);
};



#endif
