#ifndef __RL_INTERACTION_INTERFACE__
#define __RL_INTERACTION_INTERFACE__

#include <deque>
#include <nlp_socket.h>
#include "GraphCache.h"
#include "UIObject.h"
#include "SimpleEnvInterface.h"
using namespace std;


typedef deque <char*>	zchar_dq_t;

enum EnvResponseToAction_e
{
	er_error,
	er_unknown,
	er_env_changed,
	er_env_unchanged
};


//---------------------------------------------------------------
class ExperienceInterface : private CacheInterface
{
	private:
		GraphCache					o_Cache;
		SimpleEnvironmentInterface	o_EnvironmentInterface;
		CacheNode_dq_t				dq_TemporaryCacheNodes;

		bool b_ConnectedToEnvironment;
		bool b_InEpisode;
		int  i_ActionCount;
		GraphCacheNode* p_LastObservedState;
		bool b_StateChangedSinceLastObservation;


	public:
		ExperienceInterface (void);
		~ExperienceInterface (void);

		bool IsConnectedToEnvironment (void);


		//												
		bool Start (void);
		void Stop (void);

		bool KnownWorldOnly (void);
		bool StartEpisode (const char* _zRequiredStartingState);
		bool EndEpisode (void);
		void ClearEpisodeData (void);

		GraphCacheNode* MeasureState (void);
		EnvResponseToAction_e SendAction (String& _rAction);

		void LockCacheForReading (void);
		void UnlockCache (void);
		GraphCacheNode* PeekAction (String& _rAction, CacheNode* _pCurrentNode);
		GraphCache* GetCache (void)
			{ return &o_Cache; };

		//												
		bool SaveExperience (void);
};



#endif
