#ifndef __LEARNER_REPLAY_TRACE_
#define __LEARNER_REPLAY_TRACE_

#include <map>
#include <nlp_string.h>
#include "Annotation.h"
using namespace std;



class ReplayTrace;
class ReplayTraceSentence;
typedef deque <ReplayTraceSentence*>	ReplayTraceSentence_dq_t;
typedef map <String, ReplayTrace*>		IdToReplayTrace_hmp_t;
typedef deque <IdToReplayTrace_hmp_t*>	ReplayIterations_dq_t;



// ------------------------------------------------------
class ReplayTraceSentence
{
	public:
		AnnotatedAction_dq_t	dq_Action;

		~ReplayTraceSentence (void);
};



// ------------------------------------------------------
class ReplayTrace
{
	private:
		static ReplayIterations_dq_t	dq_ReplayIterations;

	public:
		String						s_ID;
		ReplayTraceSentence_dq_t	dq_Sentence;

		ReplayTrace (String& _rID);
		~ReplayTrace (void);

		static ReplayTrace* Find (int _iIteration, String& _rID);
		static bool Load (void);
};



#endif
