#ifndef __NLP_SAMPLE_DISTRIBUTION__
#define __NLP_SAMPLE_DISTRIBUTION__

#include <gsl/gsl_rng.h>
#include <gsl/gsl_randist.h>
#include <nlp_vector.h>


//---------------------------------------------------
class Sample
{
	private:
		static gsl_rng*	p_GslRng;

	public:
		static void Init (void);
		static void Destroy (void);

		static size_t SampleFromPDF (Vector <double>& _vecPDF);
		static size_t SampleFromCDF (Vector <double>& _vecPDF);
		static size_t SelectMax (Vector <double>& _vecPDF);

		static bool SampleCoinflip (double _dProbTrue);
		static int SampleUniformCategorical (int _iCategories);
};


#endif
