#ifndef __RLL_UIOBJECT__
#define __RLL_UIOBJECT__

#include <nlp_string.h>
#include <vector>
#include <deque>
#include <set>
#include <map>
#include <hash_map>
#include <ili_cache.h>
#include "nlp_vector.h"
using namespace std;



//											
class UIObject;
typedef vector <String>						String_vec_t;
typedef vector <UIObject*>					UIObject_vec_t;
typedef deque <UIObject*>					UIObject_dq_t;
typedef set <UIObject*>						UIObject_set_t;
typedef Vector <char>						Feature_vec_t;
typedef hash_map <String, int>				StringToIndex_hmp_t;



// ----------------------------------------------
class ObjectClass
{
	private:
		static StringToIndex_hmp_t	hmp_ClassToIndex;
		static String_vec_t			vec_IndexToClass;

	public:
		static int i_Count;

		static void Load (void);

		//										
		static int Find (const char* _zClass)
		{
			StringToIndex_hmp_t::iterator	ite;
			ite = hmp_ClassToIndex.find (_zClass);
			if (hmp_ClassToIndex.end () == ite)
				return 0;
			return ite->second;
		};

		static String Get (int _iIndex)
		{
			String sClass;
			if (-1 != _iIndex)
				sClass = vec_IndexToClass [_iIndex];
			return sClass;
		};
};



//-----------------------------------------------
class UIObject : public EnvObject
{
	protected:
		UIObject (void);

	public:
		String			s_Name;
		String			s_CleanName;
		int				i_Index;
		char			i_ObjectClass;

		UIObject (char* _zData, int _iObjectIndex);
		~UIObject (void);

		void SetData (char* _zData, int _iObjectIndex);
		virtual void DestroyObjects (void* _pObjects);

		static void UnpackState (String& _rState, void** _ppObjects, int* _pObjectCount);
};

std::ostream& operator<< (std::ostream& _rStream, const UIObject& _rObject);


#endif
