#ifndef __LEARNER_VOCABULARY__
#define __LEARNER_VOCABULARY__

#include <map>
#include <hash_map>
#include <vector>
#include <nlp_string.h>
using namespace std;

class Vocabulary;
typedef vector <String>			String_vec_t;
typedef hash_map <String, int>		WordToIndex_hmp_t;


// --------------------------------------------------
class Vocabulary
{
	friend class word_t;

	private:
		static WordToIndex_hmp_t	hmp_WordToIndex;

	public:
		static String_vec_t			vec_IndexToWord;
		static long l_Count;

		static bool Load (void);

		//										
		static int Find (const char* _zWord)
		{
			WordToIndex_hmp_t::iterator	ite;
			ite = hmp_WordToIndex.find (_zWord);
			if (hmp_WordToIndex.end () == ite)
			{
				cerr << "[ERROR]  Word [" << _zWord 
					 << "] not found in vocabulary." << endl;
				return -1;
			}
			return ite->second;
		};


		//										
		static int Find (String& _sWord)
		{
			WordToIndex_hmp_t::iterator	ite;
			ite = hmp_WordToIndex.find (_sWord);
			if (hmp_WordToIndex.end () == ite)
			{
				cerr << "[ERROR]  Word [" << _sWord 
					 << "] not found in vocabulary." << endl;
				return -1;
			}
			return ite->second;
		};
};


// --------------------------------------------------
class word_t
{
	private:
		long	l_WordIndex;

	public:
		word_t (const char* _zWord)		{ l_WordIndex = Vocabulary::Find (_zWord); };
		word_t (String& _sWord)			{ l_WordIndex = Vocabulary::Find (_sWord); };
		word_t (long _lIndex)			{ l_WordIndex = _lIndex; };

		operator int (void)				{ return l_WordIndex; }
		operator long (void)			{ return l_WordIndex; }
		operator String (void)			{ return Vocabulary::vec_IndexToWord [l_WordIndex]; }
		operator const char* (void)		{ return Vocabulary::vec_IndexToWord [l_WordIndex]; }
};



#endif
